<?php

namespace Drupal\custom_field\Plugin\CustomFieldType;

use Drupal\custom_field\Plugin\CustomFieldTypeBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Field\FieldItemListInterface;
use Drupal\custom_field\Plugin\Field\FieldType\CustomItem;

/**
 * Base plugin class for map custom field types.
 */
class MapBase extends CustomFieldTypeBase {

  /**
   * {@inheritdoc}
   */
  public function widget(FieldItemListInterface $items, $delta, array $element, array &$form, FormStateInterface $form_state): array {
    // Get the base form element properties.
    $element = parent::widget($items, $delta, $element, $form, $form_state);
    $is_config_form = $form_state->getBuildInfo()['base_form_id'] == 'field_config_form';
    /*
    if (!$is_config_form) {
      $element['#value'] = !empty($items[$delta]->{$this->name}) ? $items[$delta]->{$this->name} : [];
    }*/

    return [
      '#type' => 'item',
      '#default_value' => is_array($items[$delta]->{$this->name}) ? $items[$delta]->{$this->name} : [],
    ] + $element;
  }

  /**
   * {@inheritdoc}
   */
  public function widgetSettingsForm(array $form, FormStateInterface $form_state): array {

    $element = parent::widgetSettingsForm($form, $form_state);
    //unset($element['settings']);
    //unset($element['label']);

    // Some table columns containing raw markup.
    $element['description'] = [
      '#markup' => '<em>This will set a UUID on the custom field item the first time it is created and can be used as a unique identifier for the item in your custom code. This is the main use for this field type.</em>',
    ];

    return $element;
  }

  /**
   * {@inheritdoc}
   */
  public function value(CustomItem $item): string {
    $settings = $this->getWidgetSetting('settings');

    /*

    if ($this->getFormatterSetting('render') == 'key') {
      return parent::value($item);
    }
    else {
      $allowed_values = $settings['allowed_values'];
      $item_value = '';
      foreach ($allowed_values as $value) {
        if ($value['key'] === $item->{$this->name}) {
          $item_value = $value['value'];
          break;
        }
      }
      return $item_value;
    }*/
    return '';
  }

}
